"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class StructuralVariantLevelQuestions(ProtocolElement):
    """
    Structural variant level questions
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "acmgClassification",
        "confirmationDecision",
        "confirmationOutcome",
        "coordinates",
        "publications",
        "reportingQuestion",
        "variantType",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_4 import reports as reports_6_8_0

        return {
            "coordinates": reports_6_8_0.Coordinates,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_4 import reports as reports_6_8_0

        return {
            "acmgClassification": reports_6_8_0.ACMGClassification,
            "confirmationDecision": reports_6_8_0.ConfirmationDecision,
            "confirmationOutcome": reports_6_8_0.ConfirmationOutcome,
            "reportingQuestion": reports_6_8_0.ReportingQuestion,
            "variantType": reports_6_8_0.StructuralVariantType,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_4 import reports as reports_6_8_0

        return {
            "org.gel.models.report.avro.ACMGClassification": reports_6_8_0.ACMGClassification,
            "org.gel.models.report.avro.ConfirmationDecision": reports_6_8_0.ConfirmationDecision,
            "org.gel.models.report.avro.ConfirmationOutcome": reports_6_8_0.ConfirmationOutcome,
            "org.gel.models.report.avro.Coordinates": reports_6_8_0.Coordinates,
            "org.gel.models.report.avro.ReportingQuestion": reports_6_8_0.ReportingQuestion,
            "org.gel.models.report.avro.StructuralVariantType": reports_6_8_0.StructuralVariantType,
            "org.gel.models.report.avro.StructuralVariantLevelQuestions": reports_6_8_0.StructuralVariantLevelQuestions,
        }

    __slots__ = [
        "acmgClassification",
        "confirmationDecision",
        "confirmationOutcome",
        "coordinates",
        "publications",
        "reportingQuestion",
        "variantType",
    ]

    def __init__(
        self,
        acmgClassification,
        confirmationDecision,
        confirmationOutcome,
        coordinates,
        publications,
        reportingQuestion,
        variantType,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_6_8_0.StructuralVariantLevelQuestions model.

        :param acmgClassification:
            What ACMG pathogenicity score (1-5) did you assign to this variant?
        :type acmgClassification: ACMGClassification
        :param confirmationDecision:
            Did you carry out technical confirmation of this variant via an
            alternative test?
        :type confirmationDecision: ConfirmationDecision
        :param confirmationOutcome:
            Did the test confirm that the variant is present?
        :type confirmationOutcome: ConfirmationOutcome
        :param coordinates:
            Variant coordinates
        :type coordinates: Coordinates
        :param publications:
            Please provide PMIDs for papers which you have used to inform your
            assessment for this variant, separated by a `;` for
            multiple papers
        :type publications: str
        :param reportingQuestion:
            Did you include the variant in your report to the clinician?
        :type reportingQuestion: ReportingQuestion
        :param variantType:
            Structural variant type
        :type variantType: StructuralVariantType
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "6.8.0"
